## This function is part of pinkalyzer, by Jean-Luc Ohl

## wavfile = wavfile to analyze
## wavefilename = name of graph
## wavefilepath= output directory for graph files
## fext = extension for graph files, default '.png'


cd D:\documents\audio\align2\files\octave\;
wavfile1 = 'C:\Users\jlo\Desktop\pinkalyzer\test\pink-12.wav';
wavfilename1 = "pink-12.wav";
wavfilepath1 = 'C:\Users\jlo\Desktop\pinkalyzer\test\';

wavfile2 = 'C:\Users\jlo\Desktop\pinkalyzer\test\pink-18.wav';
wavfilename2 = "pink-18.wav";
wavfilepath2 = 'C:\Users\jlo\Desktop\pinkalyzer\test\';

wavfile3 = 'C:\Users\jlo\Desktop\pinkalyzer\test\pink-20.wav';
wavfilename3 = "pink-20.wav";
wavfilepath3 = 'C:\Users\jlo\Desktop\pinkalyzer\test\';

wavfile4 = 'C:\Users\jlo\Desktop\pinkalyzer\test\pink-25.wav';
wavfilename4 = "pink-25.wav";
wavfilepath4 = 'C:\Users\jlo\Desktop\pinkalyzer\test\';

fext = ".png";
fdevice = '-S1200,220';
fullscale = 0;
pink = 1;

D = [0.049922035 -0.095993537 0.050612699 -0.004408786];
C = [1 -2.494956002   2.017265875  -0.522189400];

##############################################################################	
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	# Report the stage
	disp("Analysis...");
	fflush(stdout);	

	if (fullscale == 0)	
	corr = 0;	
	else
	corr = 120;	
	endif
	
	if (pink == 0)	
	pcorr = -55;	
	else
	pcorr = 0;	
	endif
	
##############################################################################	
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(1,1,1);
	hold("on");

	# Plot 1
	subplot(1,1,1);
	
	[wav1,fs1] = wavread([wavfile1]);
	wav1L = wav1(:, 1);	
	n = min(rows(wav1L),1048576)
	wav1L = wav1L(1:n);	
	rms1L = 20 * log10(rms(wav1L))+fullscale;		
	[irm1L,ic1L] = max(abs(wav1L));	
	irm1L = 20 * log10(irm1L)+fullscale;
	cf1L = irm1L-rms1L;	
	if (pink == 1)	
	wav1Lf = filter(C,D,wav1L); 	
	else
	wav1Lf = wav1L; 
	endif
	wav1log = 20*log10(ssev(wav1Lf,fs1,0.1,1));
	corr1 =  rms1L - mean(wav1log(fs1/100:fs1/2));
	
	ixg= [1:columns(wav1log)];
	semilogx(ixg*fs1/(2000*columns(wav1log)), wav1log+corr1, ["3;" wavfilename1 " max " num2str(irm1L,3) " rms " num2str(rms1L,3) " crestf " num2str(cf1L,3) ";"],"LineWidth",DLW);
	clear wav1 wav1L wav1log irm1L rms1L;	

	[wav2,fs2] = wavread([wavfile2]);	
	wav2L = wav2(:, 1);
	n = min(rows(wav2L),1048576)	
	rms2L = 20 * log10(rms(wav2L))+fullscale;		
	[irm2L,ic2L] = max(abs(wav2L));	
	irm2L = 20 * log10(irm2L)+fullscale;
	cf2L = irm2L-rms2L;	
	if (pink == 1)	
	wav2Lf = filter(C,D,wav2L); 	
	else
	wav2Lf = wav2L; 		
	endif		
	wav2log = 20*log10(ssev(wav2Lf,fs2,0.1,1));
	corr2 =  rms2L - mean(wav2log(fs2/100:fs2/2));
	
	ixg= [1:columns(wav2log)];
	semilogx(ixg*fs2/(2000*columns(wav2log)), wav2log+corr2, ["1;" wavfilename2 " max " num2str(irm2L,3) " rms " num2str(rms2L,3) " crestf " num2str(cf2L,3) ";"],"LineWidth",DLW);
	# Remove variables no longer used
	clear wav2 wav2L wav2log irm2L rms2L;
	
	[wav3,fs3] = wavread([wavfile3]);	
	wav3L = wav3(:, 1);
	n = min(rows(wav3L),1048576)	
	rms3L = 20 * log10(rms(wav3L))+fullscale;		
	[irm3L,ic3L] = max(abs(wav3L));	
	irm3L = 20 * log10(irm3L)+fullscale;
	cf3L = irm3L-rms3L;	
	if (pink == 1)	
	wav3Lf = filter(C,D,wav3L); 	
	else
	wav3Lf = wav3L; 		
	endif		
	wav3log = 20*log10(ssev(wav3Lf,fs3,0.1,1));
	corr3 =  rms3L - mean(wav3log(fs3/100:fs3/2));	
	
	ixg= [1:columns(wav3log)];
	semilogx(ixg*fs3/(2000*columns(wav3log)), wav3log+corr3, ["2;" wavfilename3 " max " num2str(irm3L,3) " rms " num2str(rms3L,3) " crestf " num2str(cf3L,3) ";"],"LineWidth",DLW);
	clear wav3 wav3L wav3log irm3L rms3L;
	
	[wav4,fs4] = wavread([wavfile4]);	
	wav4L = wav4(:, 1);
	n = min(rows(wav4L),1048576)	
	rms4L = 20 * log10(rms(wav4L))+fullscale;		
	[irm4L,ic4L] = max(abs(wav4L));	
	irm4L = 20 * log10(irm4L)+fullscale;
	cf4L = irm4L-rms4L;	
	if (pink == 1)	
	wav4Lf = filter(C,D,wav4L); 	
	else
	wav4Lf = wav4L; 		
	endif		
	wav4log = 20*log10(ssev(wav4Lf,fs4,0.1,1));
	corr4 = rms4L - mean(wav4log(fs4/100:fs4/2));

	ixg= [1:columns(wav4log)];
	semilogx(ixg*fs4/(2000*columns(wav4log)), wav4log+corr4, ["4;" wavfilename4 " max " num2str(irm4L,3) " rms " num2str(rms4L,3) " crestf " num2str(cf4L,3) ";"],"LineWidth",DLW);
	clear wav4 wav4L wav4log irm4L rms4L;
	
	grid("on");
	axis([0.01, 22, -30+corr, corr]);
	safetics("x",[0.02,0.04,0.07,0.1,0.2,0.4,0.7,1,2,4,7,10,15,20]);
	safetics("y",-30+corr:5:corr);
	title("Spectrum");

	# Disable holding the plot and set graph parameters
	subplot(1,1,1);
	hold("off");

	# Print to the output file
	print([wavfilepath1 wavfilename1 fext ],fdevice);

	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);
	